# Define templates
include:
  - project: "${GITLAB_CI_TEMPLATES_PATH}"
    file: "${GITLAB_CI_TEMPLATES_FILE}"
    ref: "2.0.0"

# Define stages
stages:
  - build
  - predeploy
  - deploy
  - test
  - publish
  - release
  - upgrade
  - clean
  - schedule
  - scheduled-jobs

# Define global variables
variables:
  P_NAME: "sso-client-v7"
  P_APP_TYPE: "java"
  P_CODE_SRC_PATH: "."
  P_MAVEN_IMAGE_TAG: "3.6.3-jdk-8-slim"

# Define jobs
compile/unit-test:
  stage: build
  extends:
    - .buildJavaMavenTest

package:
  stage: build
  extends:
    - .buildJavaMavenPackage
  needs:
    - job: compile/unit-test
      artifacts: true
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"

static-analysis:
  stage: test
  extends:
    - .testJavaMavenSonarAnalysis
  needs:
    - job: compile/unit-test
      artifacts: true
  variables:
    P_MAVEN_EXTRA_ARGS: "-Psonar -DskipTests"

install-cache-repo:
  stage: publish
  extends:
    - .publishJavaMavenInstall
  needs:
    - job: package
      artifacts: true
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"

publish-code:
  stage: publish
  extends:
    - .publishJavaMavenDeploy
  needs:
    - job: package
      artifacts: true

release/code:
  stage: release
  extends:
    - .releaseCodeForJava
  variables:
    DISABLE_CHECK_JAVADOC: "true"
    P_MAVEN_JAVADOC_SKIP: "true"
